diff --git a/common/ppc/predict.c b/common/ppc/predict.c
index 9b38fbb..1d46de2 100644
--- a/common/ppc/predict.c
+++ b/common/ppc/predict.c
@@ -30,6 +30,7 @@ static void predict_8x8c_p_altivec( uint8_t *src )
     int H = 0;
     int V = 0;
     int i00;
+    LOAD_ZERO;
 
     for( i = 0; i < 4; i++ )
     {
@@ -54,9 +55,7 @@ static void predict_8x8c_p_altivec( uint8_t *src )
     c_v = vec_splat(c_u.v, 0);
 
     vec_s16_t induc_v  = (vec_s16_t) CV(0, 1, 2, 3, 4, 5, 6, 7);
-    vec_s32_t mule_b_v = vec_mule(induc_v, b_v);
-    vec_s32_t mulo_b_v = vec_mulo(induc_v, b_v);
-    vec_s16_t mul_b_induc0_v = vec_pack(vec_mergeh(mule_b_v, mulo_b_v), vec_mergel(mule_b_v, mulo_b_v));
+    vec_s16_t mul_b_induc0_v = vec_mladd(induc_v, b_v, zero_s16v);
     vec_s16_t add_i0_b_0v = vec_adds(i00_v, mul_b_induc0_v);
 
     PREP_STORE8;
@@ -83,6 +82,7 @@ static void predict_16x16_p_altivec( uint8_t *src )
     int H = 0;
     int V = 0;
     int16_t i00;
+    LOAD_ZERO;
 
     for( i = 1; i <= 8; i++ )
     {
@@ -107,9 +107,7 @@ static void predict_16x16_p_altivec( uint8_t *src )
     c_v = vec_splat(c_u.v, 0);
     vec_s16_t induc_v  = (vec_s16_t) CV(0,  1,  2,  3,  4,  5,  6,  7);
     vec_s16_t b8_v = vec_sl(b_v, vec_splat_u16(3));
-    vec_s32_t mule_b_v = vec_mule(induc_v, b_v);
-    vec_s32_t mulo_b_v = vec_mulo(induc_v, b_v);
-    vec_s16_t mul_b_induc0_v = vec_pack(vec_mergeh(mule_b_v, mulo_b_v), vec_mergel(mule_b_v, mulo_b_v));
+    vec_s16_t mul_b_induc0_v = vec_mladd(induc_v, b_v, zero_s16v);
     vec_s16_t add_i0_b_0v = vec_adds(i00_v, mul_b_induc0_v);
     vec_s16_t add_i0_b_8v = vec_adds(b8_v, add_i0_b_0v);
 